Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/vector.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -645,79 +770,79 @@
 bool Vector::LSQdistance(Vector **vectors, int num)
 {
-	int j;
-
-	for (j=0;j<num;j++) {
-		cout << Verbose(1) << j << "th atom's vector: ";
-		(vectors[j])->Output((ofstream *)&cout);
-		cout << endl;
-	}
-
-	int np = 3;
-	struct LSQ_params par;
-
-	 const gsl_multimin_fminimizer_type *T =
-		 gsl_multimin_fminimizer_nmsimplex;
-	 gsl_multimin_fminimizer *s = NULL;
-	 gsl_vector *ss, *y;
-	 gsl_multimin_function minex_func;
-
-	 size_t iter = 0, i;
-	 int status;
-	 double size;
-
-	 /* Initial vertex size vector */
-	 ss = gsl_vector_alloc (np);
-	 y = gsl_vector_alloc (np);
-
-	 /* Set all step sizes to 1 */
-	 gsl_vector_set_all (ss, 1.0);
-
-	 /* Starting point */
-	 par.vectors = vectors;
-	 par.num = num;
-
-	 for (i=NDIM;i--;)
-		gsl_vector_set(y, i, (vectors[0]->x[i] - vectors[1]->x[i])/2.);
-
-	 /* Initialize method and iterate */
-	 minex_func.f = &LSQ;
-	 minex_func.n = np;
-	 minex_func.params = (void *)&par;
-
-	 s = gsl_multimin_fminimizer_alloc (T, np);
-	 gsl_multimin_fminimizer_set (s, &minex_func, y, ss);
-
-	 do
-		 {
-			 iter++;
-			 status = gsl_multimin_fminimizer_iterate(s);
-
-			 if (status)
-				 break;
-
-			 size = gsl_multimin_fminimizer_size (s);
-			 status = gsl_multimin_test_size (size, 1e-2);
-
-			 if (status == GSL_SUCCESS)
-				 {
-					 printf ("converged to minimum at\n");
-				 }
-
-			 printf ("%5d ", (int)iter);
-			 for (i = 0; i < (size_t)np; i++)
-				 {
-					 printf ("%10.3e ", gsl_vector_get (s->x, i));
-				 }
-			 printf ("f() = %7.3f size = %.3f\n", s->fval, size);
-		 }
-	 while (status == GSL_CONTINUE && iter < 100);
-
-	for (i=(size_t)np;i--;)
-		this->x[i] = gsl_vector_get(s->x, i);
-	 gsl_vector_free(y);
-	 gsl_vector_free(ss);
-	 gsl_multimin_fminimizer_free (s);
-
-	return true;
+  int j;
+
+  for (j=0;j<num;j++) {
+    cout << Verbose(1) << j << "th atom's vector: ";
+    (vectors[j])->Output((ofstream *)&cout);
+    cout << endl;
+  }
+
+  int np = 3;
+  struct LSQ_params par;
+
+   const gsl_multimin_fminimizer_type *T =
+     gsl_multimin_fminimizer_nmsimplex;
+   gsl_multimin_fminimizer *s = NULL;
+   gsl_vector *ss, *y;
+   gsl_multimin_function minex_func;
+
+   size_t iter = 0, i;
+   int status;
+   double size;
+
+   /* Initial vertex size vector */
+   ss = gsl_vector_alloc (np);
+   y = gsl_vector_alloc (np);
+
+   /* Set all step sizes to 1 */
+   gsl_vector_set_all (ss, 1.0);
+
+   /* Starting point */
+   par.vectors = vectors;
+   par.num = num;
+
+   for (i=NDIM;i--;)
+    gsl_vector_set(y, i, (vectors[0]->x[i] - vectors[1]->x[i])/2.);
+
+   /* Initialize method and iterate */
+   minex_func.f = &LSQ;
+   minex_func.n = np;
+   minex_func.params = (void *)&par;
+
+   s = gsl_multimin_fminimizer_alloc (T, np);
+   gsl_multimin_fminimizer_set (s, &minex_func, y, ss);
+
+   do
+     {
+       iter++;
+       status = gsl_multimin_fminimizer_iterate(s);
+
+       if (status)
+         break;
+
+       size = gsl_multimin_fminimizer_size (s);
+       status = gsl_multimin_test_size (size, 1e-2);
+
+       if (status == GSL_SUCCESS)
+         {
+           printf ("converged to minimum at\n");
+         }
+
+       printf ("%5d ", (int)iter);
+       for (i = 0; i < (size_t)np; i++)
+         {
+           printf ("%10.3e ", gsl_vector_get (s->x, i));
+         }
+       printf ("f() = %7.3f size = %.3f\n", s->fval, size);
+     }
+   while (status == GSL_CONTINUE && iter < 100);
+
+  for (i=(size_t)np;i--;)
+    this->x[i] = gsl_vector_get(s->x, i);
+   gsl_vector_free(y);
+   gsl_vector_free(ss);
+   gsl_multimin_fminimizer_free (s);
+
+  return true;
 };
 
@@ -727,6 +852,6 @@
 void Vector::AddVector(const Vector *y)
 {
-	for (int i=NDIM;i--;)
-		this->x[i] += y->x[i];
+  for (int i=NDIM;i--;)
+    this->x[i] += y->x[i];
 }
 
@@ -736,6 +861,6 @@
 void Vector::SubtractVector(const Vector *y)
 {
-	for (int i=NDIM;i--;)
-		this->x[i] -= y->x[i];
+  for (int i=NDIM;i--;)
+    this->x[i] -= y->x[i];
 }
 
@@ -745,6 +870,6 @@
 void Vector::CopyVector(const Vector *y)
 {
-	for (int i=NDIM;i--;)
-		this->x[i] = y->x[i];
+  for (int i=NDIM;i--;)
+    this->x[i] = y->x[i];
 }
 
@@ -756,13 +881,13 @@
 void Vector::AskPosition(double *cell_size, bool check)
 {
-	char coords[3] = {'x','y','z'};
-	int j = -1;
-	for (int i=0;i<3;i++) {
-		j += i+1;
-		do {
-			cout << Verbose(0) << coords[i] << "[0.." << cell_size[j] << "]: ";
-			cin >> x[i];
-		} while (((x[i] < 0) || (x[i] >= cell_size[j])) && (check));
-	}
+  char coords[3] = {'x','y','z'};
+  int j = -1;
+  for (int i=0;i<3;i++) {
+    j += i+1;
+    do {
+      cout << Verbose(0) << coords[i] << "[0.." << cell_size[j] << "]: ";
+      cin >> x[i];
+    } while (((x[i] < 0) || (x[i] >= cell_size[j])) && (check));
+  }
 };
 
@@ -784,155 +909,155 @@
 bool Vector::SolveSystem(Vector *x1, Vector *x2, Vector *y, double alpha, double beta, double c)
 {
-	double D1,D2,D3,E1,E2,F1,F2,F3,p,q=0., A, B1, B2, C;
-	double ang; // angle on testing
-	double sign[3];
-	int i,j,k;
-	A = cos(alpha) * x1->Norm() * c;
-	B1 = cos(beta + M_PI/2.) * y->Norm() * c;
-	B2 = cos(beta) * x2->Norm() * c;
-	C = c * c;
-	cout << Verbose(2) << "A " << A << "\tB " << B1 << "\tC " << C << endl;
-	int flag = 0;
-	if (fabs(x1->x[0]) < MYEPSILON) { // check for zero components for the later flipping and back-flipping
-		if (fabs(x1->x[1]) > MYEPSILON) {
-			flag = 1;
-		} else if (fabs(x1->x[2]) > MYEPSILON) {
-			 flag = 2;
-		} else {
-			return false;
-		}
-	}
-	switch (flag) {
-		default:
-		case 0:
-			break;
-		case 2:
-			flip(&x1->x[0],&x1->x[1]);
-			flip(&x2->x[0],&x2->x[1]);
-			flip(&y->x[0],&y->x[1]);
-			//flip(&x[0],&x[1]);
-			flip(&x1->x[1],&x1->x[2]);
-			flip(&x2->x[1],&x2->x[2]);
-			flip(&y->x[1],&y->x[2]);
-			//flip(&x[1],&x[2]);
-		case 1:
-			flip(&x1->x[0],&x1->x[1]);
-			flip(&x2->x[0],&x2->x[1]);
-			flip(&y->x[0],&y->x[1]);
-			//flip(&x[0],&x[1]);
-			flip(&x1->x[1],&x1->x[2]);
-			flip(&x2->x[1],&x2->x[2]);
-			flip(&y->x[1],&y->x[2]);
-			//flip(&x[1],&x[2]);
-			break;
-	}
-	// now comes the case system
-	D1 = -y->x[0]/x1->x[0]*x1->x[1]+y->x[1];
-	D2 = -y->x[0]/x1->x[0]*x1->x[2]+y->x[2];
-	D3 = y->x[0]/x1->x[0]*A-B1;
-	cout << Verbose(2) << "D1 " << D1 << "\tD2 " << D2 << "\tD3 " << D3 << "\n";
-	if (fabs(D1) < MYEPSILON) {
-		cout << Verbose(2) << "D1 == 0!\n";
-		if (fabs(D2) > MYEPSILON) {
-			cout << Verbose(3) << "D2 != 0!\n";
-			x[2] = -D3/D2;
-			E1 = A/x1->x[0] + x1->x[2]/x1->x[0]*D3/D2;
-			E2 = -x1->x[1]/x1->x[0];
-			cout << Verbose(3) << "E1 " << E1 << "\tE2 " << E2 << "\n";
-			F1 = E1*E1 + 1.;
-			F2 = -E1*E2;
-			F3 = E1*E1 + D3*D3/(D2*D2) - C;
-			cout << Verbose(3) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
-			if (fabs(F1) < MYEPSILON) {
-				cout << Verbose(4) << "F1 == 0!\n";
-				cout << Verbose(4) << "Gleichungssystem linear\n";
-				x[1] = F3/(2.*F2);
-			} else {
-				p = F2/F1;
-				q = p*p - F3/F1;
-				cout << Verbose(4) << "p " << p << "\tq " << q << endl;
-				if (q < 0) {
-					cout << Verbose(4) << "q < 0" << endl;
-					return false;
-				}
-				x[1] = p + sqrt(q);
-			}
-			x[0] =	A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
-		} else {
-			cout << Verbose(2) << "Gleichungssystem unterbestimmt\n";
-			return false;
-		}
-	} else {
-		E1 = A/x1->x[0]+x1->x[1]/x1->x[0]*D3/D1;
-		E2 = x1->x[1]/x1->x[0]*D2/D1 - x1->x[2];
-		cout << Verbose(2) << "E1 " << E1 << "\tE2 " << E2 << "\n";
-		F1 = E2*E2 + D2*D2/(D1*D1) + 1.;
-		F2 = -(E1*E2 + D2*D3/(D1*D1));
-		F3 = E1*E1 + D3*D3/(D1*D1) - C;
-		cout << Verbose(2) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
-		if (fabs(F1) < MYEPSILON) {
-			cout << Verbose(3) << "F1 == 0!\n";
-			cout << Verbose(3) << "Gleichungssystem linear\n";
-			x[2] = F3/(2.*F2);
-		} else {
-			p = F2/F1;
-			q = p*p - F3/F1;
-			cout << Verbose(3) << "p " << p << "\tq " << q << endl;
-			if (q < 0) {
-				cout << Verbose(3) << "q < 0" << endl;
-				return false;
-			}
-			x[2] = p + sqrt(q);
-		}
-		x[1] = (-D2 * x[2] - D3)/D1;
-		x[0] = A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
-	}
-	switch (flag) { // back-flipping
-		default:
-		case 0:
-			break;
-		case 2:
-			flip(&x1->x[0],&x1->x[1]);
-			flip(&x2->x[0],&x2->x[1]);
-			flip(&y->x[0],&y->x[1]);
-			flip(&x[0],&x[1]);
-			flip(&x1->x[1],&x1->x[2]);
-			flip(&x2->x[1],&x2->x[2]);
-			flip(&y->x[1],&y->x[2]);
-			flip(&x[1],&x[2]);
-		case 1:
-			flip(&x1->x[0],&x1->x[1]);
-			flip(&x2->x[0],&x2->x[1]);
-			flip(&y->x[0],&y->x[1]);
-			//flip(&x[0],&x[1]);
-			flip(&x1->x[1],&x1->x[2]);
-			flip(&x2->x[1],&x2->x[2]);
-			flip(&y->x[1],&y->x[2]);
-			flip(&x[1],&x[2]);
-			break;
-	}
-	// one z component is only determined by its radius (without sign)
-	// thus check eight possible sign flips and determine by checking angle with second vector
-	for (i=0;i<8;i++) {
-		// set sign vector accordingly
-		for (j=2;j>=0;j--) {
-			k = (i & pot(2,j)) << j;
-			cout << Verbose(2) << "k " << k << "\tpot(2,j) " << pot(2,j) << endl;
-			sign[j] = (k == 0) ? 1. : -1.;
-		}
-		cout << Verbose(2) << i << ": sign matrix is " << sign[0] << "\t" << sign[1] << "\t" << sign[2] << "\n";
-		// apply sign matrix
-		for (j=NDIM;j--;)
-			x[j] *= sign[j];
-		// calculate angle and check
-		ang = x2->Angle (this);
-		cout << Verbose(1) << i << "th angle " << ang << "\tbeta " << cos(beta) << " :\t";
-		if (fabs(ang - cos(beta)) < MYEPSILON) {
-			break;
-		}
-		// unapply sign matrix (is its own inverse)
-		for (j=NDIM;j--;)
-			x[j] *= sign[j];
-	}
-	return true;
-};
+  double D1,D2,D3,E1,E2,F1,F2,F3,p,q=0., A, B1, B2, C;
+  double ang; // angle on testing
+  double sign[3];
+  int i,j,k;
+  A = cos(alpha) * x1->Norm() * c;
+  B1 = cos(beta + M_PI/2.) * y->Norm() * c;
+  B2 = cos(beta) * x2->Norm() * c;
+  C = c * c;
+  cout << Verbose(2) << "A " << A << "\tB " << B1 << "\tC " << C << endl;
+  int flag = 0;
+  if (fabs(x1->x[0]) < MYEPSILON) { // check for zero components for the later flipping and back-flipping
+    if (fabs(x1->x[1]) > MYEPSILON) {
+      flag = 1;
+    } else if (fabs(x1->x[2]) > MYEPSILON) {
+       flag = 2;
+    } else {
+      return false;
+    }
+  }
+  switch (flag) {
+    default:
+    case 0:
+      break;
+    case 2:
+      flip(&x1->x[0],&x1->x[1]);
+      flip(&x2->x[0],&x2->x[1]);
+      flip(&y->x[0],&y->x[1]);
+      //flip(&x[0],&x[1]);
+      flip(&x1->x[1],&x1->x[2]);
+      flip(&x2->x[1],&x2->x[2]);
+      flip(&y->x[1],&y->x[2]);
+      //flip(&x[1],&x[2]);
+    case 1:
+      flip(&x1->x[0],&x1->x[1]);
+      flip(&x2->x[0],&x2->x[1]);
+      flip(&y->x[0],&y->x[1]);
+      //flip(&x[0],&x[1]);
+      flip(&x1->x[1],&x1->x[2]);
+      flip(&x2->x[1],&x2->x[2]);
+      flip(&y->x[1],&y->x[2]);
+      //flip(&x[1],&x[2]);
+      break;
+  }
+  // now comes the case system
+  D1 = -y->x[0]/x1->x[0]*x1->x[1]+y->x[1];
+  D2 = -y->x[0]/x1->x[0]*x1->x[2]+y->x[2];
+  D3 = y->x[0]/x1->x[0]*A-B1;
+  cout << Verbose(2) << "D1 " << D1 << "\tD2 " << D2 << "\tD3 " << D3 << "\n";
+  if (fabs(D1) < MYEPSILON) {
+    cout << Verbose(2) << "D1 == 0!\n";
+    if (fabs(D2) > MYEPSILON) {
+      cout << Verbose(3) << "D2 != 0!\n";
+      x[2] = -D3/D2;
+      E1 = A/x1->x[0] + x1->x[2]/x1->x[0]*D3/D2;
+      E2 = -x1->x[1]/x1->x[0];
+      cout << Verbose(3) << "E1 " << E1 << "\tE2 " << E2 << "\n";
+      F1 = E1*E1 + 1.;
+      F2 = -E1*E2;
+      F3 = E1*E1 + D3*D3/(D2*D2) - C;
+      cout << Verbose(3) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
+      if (fabs(F1) < MYEPSILON) {
+        cout << Verbose(4) << "F1 == 0!\n";
+        cout << Verbose(4) << "Gleichungssystem linear\n";
+        x[1] = F3/(2.*F2);
+      } else {
+        p = F2/F1;
+        q = p*p - F3/F1;
+        cout << Verbose(4) << "p " << p << "\tq " << q << endl;
+        if (q < 0) {
+          cout << Verbose(4) << "q < 0" << endl;
+          return false;
+        }
+        x[1] = p + sqrt(q);
+      }
+      x[0] =  A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
+    } else {
+      cout << Verbose(2) << "Gleichungssystem unterbestimmt\n";
+      return false;
+    }
+  } else {
+    E1 = A/x1->x[0]+x1->x[1]/x1->x[0]*D3/D1;
+    E2 = x1->x[1]/x1->x[0]*D2/D1 - x1->x[2];
+    cout << Verbose(2) << "E1 " << E1 << "\tE2 " << E2 << "\n";
+    F1 = E2*E2 + D2*D2/(D1*D1) + 1.;
+    F2 = -(E1*E2 + D2*D3/(D1*D1));
+    F3 = E1*E1 + D3*D3/(D1*D1) - C;
+    cout << Verbose(2) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
+    if (fabs(F1) < MYEPSILON) {
+      cout << Verbose(3) << "F1 == 0!\n";
+      cout << Verbose(3) << "Gleichungssystem linear\n";
+      x[2] = F3/(2.*F2);
+    } else {
+      p = F2/F1;
+      q = p*p - F3/F1;
+      cout << Verbose(3) << "p " << p << "\tq " << q << endl;
+      if (q < 0) {
+        cout << Verbose(3) << "q < 0" << endl;
+        return false;
+      }
+      x[2] = p + sqrt(q);
+    }
+    x[1] = (-D2 * x[2] - D3)/D1;
+    x[0] = A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
+  }
+  switch (flag) { // back-flipping
+    default:
+    case 0:
+      break;
+    case 2:
+      flip(&x1->x[0],&x1->x[1]);
+      flip(&x2->x[0],&x2->x[1]);
+      flip(&y->x[0],&y->x[1]);
+      flip(&x[0],&x[1]);
+      flip(&x1->x[1],&x1->x[2]);
+      flip(&x2->x[1],&x2->x[2]);
+      flip(&y->x[1],&y->x[2]);
+      flip(&x[1],&x[2]);
+    case 1:
+      flip(&x1->x[0],&x1->x[1]);
+      flip(&x2->x[0],&x2->x[1]);
+      flip(&y->x[0],&y->x[1]);
+      //flip(&x[0],&x[1]);
+      flip(&x1->x[1],&x1->x[2]);
+      flip(&x2->x[1],&x2->x[2]);
+      flip(&y->x[1],&y->x[2]);
+      flip(&x[1],&x[2]);
+      break;
+  }
+  // one z component is only determined by its radius (without sign)
+  // thus check eight possible sign flips and determine by checking angle with second vector
+  for (i=0;i<8;i++) {
+    // set sign vector accordingly
+    for (j=2;j>=0;j--) {
+      k = (i & pot(2,j)) << j;
+      cout << Verbose(2) << "k " << k << "\tpot(2,j) " << pot(2,j) << endl;
+      sign[j] = (k == 0) ? 1. : -1.;
+    }
+    cout << Verbose(2) << i << ": sign matrix is " << sign[0] << "\t" << sign[1] << "\t" << sign[2] << "\n";
+    // apply sign matrix
+    for (j=NDIM;j--;)
+      x[j] *= sign[j];
+    // calculate angle and check
+    ang = x2->Angle (this);
+    cout << Verbose(1) << i << "th angle " << ang << "\tbeta " << cos(beta) << " :\t";
+    if (fabs(ang - cos(beta)) < MYEPSILON) {
+      break;
+    }
+    // unapply sign matrix (is its own inverse)
+    for (j=NDIM;j--;)
+      x[j] *= sign[j];
+  }
+  return true;
+};
Index: src/vector.hpp
===================================================================
--- src/vector.hpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/vector.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -8,50 +8,53 @@
  */
 class Vector {
-	public:
-		double x[NDIM];
+  public:
+    double x[NDIM];
 
-	Vector();
-	Vector(double x1, double x2, double x3);
-	~Vector();
+  Vector();
+  Vector(double x1, double x2, double x3);
+  ~Vector();
 
-	double Distance(const Vector *y) const;
-	double DistanceSquared(const Vector *y) const;
-	double PeriodicDistance(const Vector *y, const double *cell_size) const;
-	double PeriodicDistanceSquared(const Vector *y, const double *cell_size) const;
-	double ScalarProduct(const Vector *y) const;
-	double Projection(const Vector *y) const;
-	double Norm() const ;
-	double Angle(const Vector *y) const;
-	bool IsNull();
+  double Distance(const Vector *y) const;
+  double DistanceSquared(const Vector *y) const;
+  double PeriodicDistance(const Vector *y, const double *cell_size) const;
+  double PeriodicDistanceSquared(const Vector *y, const double *cell_size) const;
+  double ScalarProduct(const Vector *y) const;
+  double Projection(const Vector *y) const;
+  double Norm() const;
+  double NormSquared() const;
+  double Angle(const Vector *y) const;
+  bool IsNull();
 
-
-	void AddVector(const Vector *y);
-	void SubtractVector(const Vector *y);
-	void CopyVector(const Vector *y);
-	void RotateVector(const Vector *y, const double alpha);
-	void VectorProduct(const Vector *y);
-	void ProjectOntoPlane(const Vector *y);
-	void Zero();
-	void One(double one);
-	void Init(double x1, double x2, double x3);
-	void Normalize();
-	void Translate(const Vector *x);
-	void Mirror(const Vector *x);
-	void Scale(double **factor);
-	void Scale(double *factor);
-	void Scale(double factor);
-	void MatrixMultiplication(double *M);
-	void InverseMatrixMultiplication(double *M);
-	void KeepPeriodic(ofstream *out, double *matrix);
-	void LinearCombinationOfVectors(const Vector *x1, const Vector *x2, const Vector *x3, double *factors);
-	double CutsPlaneAt(Vector *A, Vector *B, Vector *C);
-	bool GetOneNormalVector(const Vector *x1);
-	bool MakeNormalVector(const Vector *y1);
-	bool MakeNormalVector(const Vector *y1, const Vector *y2);
-	bool MakeNormalVector(const Vector *x1, const Vector *x2, const Vector *x3);
-	bool SolveSystem(Vector *x1, Vector *x2, Vector *y, double alpha, double beta, double c);
-	bool LSQdistance(Vector **vectors, int dim);
-	void AskPosition(double *cell_size, bool check);
-	bool Output(ofstream *out) const;
+  void AddVector(const Vector *y);
+  void SubtractVector(const Vector *y);
+  void CopyVector(const Vector *y);
+  void RotateVector(const Vector *y, const double alpha);
+  void VectorProduct(const Vector *y);
+  void ProjectOntoPlane(const Vector *y);
+  void Zero();
+  void One(double one);
+  void Init(double x1, double x2, double x3);
+  void Normalize();
+  void Translate(const Vector *x);
+  void Mirror(const Vector *x);
+  void Scale(double **factor);
+  void Scale(double *factor);
+  void Scale(double factor);
+  void MatrixMultiplication(double *M);
+  double * InverseMatrix(double *A);
+  void InverseMatrixMultiplication(double *M);
+  void KeepPeriodic(ofstream *out, double *matrix);
+  void LinearCombinationOfVectors(const Vector *x1, const Vector *x2, const Vector *x3, double *factors);
+  double CutsPlaneAt(Vector *A, Vector *B, Vector *C);
+  bool GetIntersectionWithPlane(ofstream *out, Vector *PlaneNormal, Vector *PlaneOffset, Vector *LineVector, Vector *LineVector2);
+  bool GetIntersectionOfTwoLinesOnPlane(ofstream *out, Vector *Line1a, Vector *Line1b, Vector *Line2a, Vector *Line2b);
+  bool GetOneNormalVector(const Vector *x1);
+  bool MakeNormalVector(const Vector *y1);
+  bool MakeNormalVector(const Vector *y1, const Vector *y2);
+  bool MakeNormalVector(const Vector *x1, const Vector *x2, const Vector *x3);
+  bool SolveSystem(Vector *x1, Vector *x2, Vector *y, double alpha, double beta, double c);
+  bool LSQdistance(Vector **vectors, int dim);
+  void AskPosition(double *cell_size, bool check);
+  bool Output(ofstream *out) const;
 };
 
